package org.apache.maven.deploy.deployers;

/* ====================================================================
 *   Copyright 2001-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 * ====================================================================
 */

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import org.apache.commons.httpclient.Credentials;
import org.apache.commons.httpclient.Header;
import org.apache.commons.httpclient.HostConfiguration;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.UsernamePasswordCredentials;
import org.apache.commons.httpclient.methods.PutMethod;
import org.apache.maven.deploy.RepositoryInfo;
import org.apache.maven.deploy.DeployRequest;
import org.apache.maven.deploy.exceptions.TransferFailedException;

/**
 * An HTTP deployer based the Commons HttpClient library.
 *
 * @author <a href="mailto:jason@zenplex.com">Jason van Zyl</a>
 * @version $Id: HttpDeployer.java,v 1.6 2004/03/02 14:59:31 evenisse Exp $
 * 
 * @todo still have to account for differing setups for people deploying to
 *       their own sites and to the central repository.
 *
 * @todo deal with proxies
 * @todo deal with authentication
 * 
 * @todo this class in not really functional. It should be completly refactored.
 */
public class HttpDeployer extends AbstractDeployer
{
    private RepositoryInfo repoInfo;


    /**Protocol understood by by this deployer*/
    public final static String PROTOCOL = "http://";
    
    
    /* (non-Javadoc)
     * @see org.apache.maven.deploy.deployers.Deployer#init(org.apache.maven.deploy.HostInfo)
     */
    public void init(RepositoryInfo repoInfo)
        
    {
       this.repoInfo = repoInfo;   

    }

    /* (non-Javadoc)
     * @see org.apache.maven.deploy.deployers.Deployer#release()
     */
    public void release()
    {
        // TODO Auto-generated method stub

    }

    /**
     * Description of the Method
     */
    public void deploy(DeployRequest request) throws TransferFailedException
    {
        URL url = null;
        try
        {
            url = new URL(repoInfo.getUrl());
        }
        catch (MalformedURLException murle)
        {
        }

        Credentials creds =
            new UsernamePasswordCredentials(
        repoInfo.getUserName(),
        repoInfo.getPassword());                

        //create a singular HttpClient object
        HttpClient client = new HttpClient();
        

        //establish a connection within 5 seconds
        client.setConnectionTimeout(5000);

        //set username / password
        if (creds != null)
        {
            client.getState().setCredentials(null, creds);
        }

        //
        HostConfiguration hc = new HostConfiguration();
        hc.setHost(repoInfo.getHost());              
        //start a session with the webserver
        client.setHostConfiguration(hc);

        //create a method object
        PutMethod method = new PutMethod(url.getPath());
        
        try
        {
           method.setRequestBody(new FileInputStream(request.getSrcFile()));
        }
        catch(FileNotFoundException io)
        {
          throw new TransferFailedException("input file: '"+ request.getSrcFile() + " not found ");
        }  

        //turn follow redirects off
        method.setFollowRedirects(false);

        //turn strict mode on
        method.setStrictMode(false);

        //execute the method
        try
        {
            client.executeMethod(method);
        }
        catch (HttpException he)
        {
            System.err.println("Http error connecting to '" + url + "'");
            System.err.println(he.getMessage());
            System.exit(-4);
        }
        catch (IOException ioe)
        {
            System.err.println("Unable to connect to '" + url + "'");
            System.exit(-3);
        }

        //get the request headers
        Header[] requestHeaders = method.getRequestHeaders();

        //get the response headers
        Header[] responseHeaders = method.getResponseHeaders();

        //get the response body
        byte[] responseBody = method.getResponseBody();

        method.releaseConnection();
    }
}
